/*
 * preferences.js
 *
 * Copyright (c) 2005 by Daniel Potter.  All rights reserved.
 *
 * This file is part of the Vana'diel Clock.
 *
 * The Vana'diel Clock is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * The Vana'diel Clock is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the Vana'diel Clock; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 *
 * Generic method for obtaining preferences.
 */

// Loads the preferences through a JavaScript object.

function getVanadielClockPreferences(prefs) {
    var res = new Object();

    if (prefs == null) {
	prefs = Components.classes["@mozilla.org/preferences-service;1"].
               getService(Components.interfaces.nsIPrefBranch);
    }
    res.showClock = prefs.getBoolPref("vanadiel.clock.show");
    res.showMoon = prefs.getBoolPref("vanadiel.clock.moon");
    res.showDate = prefs.getBoolPref("vanadiel.clock.date");
    res.use24HourClock = prefs.getBoolPref("vanadiel.clock.earth.24hour");
    res.minSeparator = prefs.getCharPref("vanadiel.clock.earth.separator.min");
    res.secSeparator = prefs.getCharPref("vanadiel.clock.earth.separator.sec");
    res.displayTab = prefs.getIntPref("vanadiel.clock.tab");
    res.useMoonCanvas = prefs.getBoolPref("vanadiel.clock.moon.canvas");
    res.useIncrementalMoon = prefs.getBoolPref("vanadiel.clock.moon.canvas.incremental");
    res.useMoonTint = prefs.getBoolPref("vanadiel.clock.moon.canvas.tint");
    res.enableAlarm = prefs.getBoolPref("vanadiel.clock.alarm.enable");
    res.alarmAnnounceType = prefs.getCharPref("vanadiel.clock.alarm.announce");

    res.save = function(prefs) {
	if (prefs == null) {
	    prefs = Components.classes["@mozilla.org/preferences-service;1"].
		   getService(Components.interfaces.nsIPrefBranch);
	}
	prefs.setBoolPref("vanadiel.clock.show", this.showClock);
	prefs.setBoolPref("vanadiel.clock.moon", this.showMoon);
	prefs.setBoolPref("vanadiel.clock.date", this.showDate);
	prefs.setBoolPref("vanadiel.clock.earth.24hour", this.use24HourClock);
	prefs.setCharPref("vanadiel.clock.earth.separator.min", this.minSeparator);
	prefs.setCharPref("vanadiel.clock.earth.separator.sec", this.secSeparator);
	prefs.setIntPref("vanadiel.clock.tab", this.displayTab);
	prefs.setBoolPref("vanadiel.clock.moon.canvas", this.useMoonCanvas);
	prefs.setBoolPref("vanadiel.clock.moon.canvas.incremental", this.useIncrementalMoon);
	prefs.setBoolPref("vanadiel.clock.moon.canvas.tint", this.useMoonTint);
	prefs.setBoolPref("vanadiel.clock.alarm.enable", this.enableAlarm);
	prefs.setCharPref("vanadiel.clock.alarm.announce", this.alarmAnnounceType);
    }

    return res;
}